﻿using System;
using System.Linq;
using System.Windows.Forms;
using System.Collections.Generic;

/*                Backpropagation  Test for Iris data                            */
/*                                                                               */
/*                       www.mosismath.com                                       */

namespace WindowsFormsApplication1
{
   
    public partial class Mainwin : Form
    {

        int samples = 29;
        int dataLength = 0;
        const int features = 4;
        int layers = 0;
    
        TData data = new TData();
        List<TLayer> net = new List<TLayer>();

        public Mainwin()
        {
            int i,j;
            DataGridViewCell cell;
            TLayer actLayer;

            InitializeComponent();
            data.readData(Application.StartupPath + "\\Data_iris_test.csv");
             
            actLayer = new TLayer(4, 2);
            //actLayer.Act = actLayer.Relu;
            //actLayer.dAct = actLayer.dRelu;
            net.Add(actLayer);
            actLayer = new TLayer(2, 2);
            net.Add(actLayer);

            layers = net.Count;

            // initialisation for testing with the sigmoid function
            // uncomment the use of the sigmoid function in the TLayer class
            /* actLayer = net.ElementAt(0); 
             actLayer.w[0, 0] = -0.417177331896259;
             actLayer.w[0, 1] = -0.417177331896259;
             actLayer.w[1, 0] = -0.81815855501829526;
             actLayer.w[1, 1] = -0.81815855501829526;
             actLayer.w[2, 0] = 1.1323298298986815;
             actLayer.w[2, 1] = 1.1323298298986815;
             actLayer.w[3, 0] = 2.0819291827710265;
             actLayer.w[3, 1] = 2.0819291827710265;

             actLayer.offs[0] = -8.3299222747040869;
             actLayer.offs[1] = -8.3299222747040869;

             actLayer = net.ElementAt(1);
             actLayer.w[0, 0] = 164.8381761203876;
             actLayer.w[0, 1] = 96.734822782075483;
             actLayer.w[1, 0] = 164.8381761203876;
             actLayer.w[1, 1] = 96.734822782075483;

             actLayer.offs[0] = -7.8106904250066105;
             actLayer.offs[1] = -20.9001399096394;*/

            // initialisation for testing with the tanh
            // uncomment the use of the tanh function in the TLayer class
             actLayer = net.ElementAt(0); 
             actLayer.w[0, 0] = -0.34079058197934764;
             actLayer.w[0, 1] = -0.34079058197934764;
             actLayer.w[1, 0] = -0.43101455307327857;
             actLayer.w[1, 1] = -0.43101455307327857;
             actLayer.w[2, 0] = 0.75602580069112557;
             actLayer.w[2, 1] = 0.75602580069112557;
             actLayer.w[3, 0] = 0.83135263550201643;
             actLayer.w[3, 1] = 0.83135263550201643;

             actLayer.offs[0] = -0.87352199822696541;
             actLayer.offs[1] = -0.87352199822696541;

             actLayer = net.ElementAt(1);
             actLayer.w[0, 0] = 7.2545311312958951;
             actLayer.w[0, 1] = 13.098159514712675;
             actLayer.w[1, 0] = 7.2545311312958951;
             actLayer.w[1, 1] = 13.098159514712675;

             actLayer.offs[0] = -3.7472829213389747;
             actLayer.offs[1] = -22.528282718620552;

            // initialisation for testing with the tanh with relu
            // uncomment the use of the tanh function in the TLayer class
            /*  actLayer = net.ElementAt(0); 
              actLayer.w[0, 0] = -1.5848395287999952;
              actLayer.w[0, 1] = -1.5848395287999952;
              actLayer.w[1, 0] = -1.8815925522874668;
              actLayer.w[1, 1] = -1.8815925522874668;
              actLayer.w[2, 0] = 3.8387901519145329;
              actLayer.w[2, 1] = 3.8387901519145329;
              actLayer.w[3, 0] = 3.5858361165720343;
              actLayer.w[3, 1] = 3.5858361165720343;

              actLayer.offs[0] = -2.9788353614557468;
              actLayer.offs[1] = -2.9788353614557468;

              actLayer = net.ElementAt(1);
              actLayer.w[0, 0] = 28.81706657810102;
              actLayer.w[0, 1] = 1.5649981260071342;
              actLayer.w[1, 0] = 28.81706657810102;
              actLayer.w[1, 1] = 1.5649981260071342;

              actLayer.offs[0] = -5.0238090560955149;
              actLayer.offs[1] = -21.013780166390603;*/

            // initialisation for testing with the sigmoid with relu
            // uncomment the use of the tanh function in the TLayer class
             /* actLayer = net.ElementAt(0); 
              actLayer.w[0, 0] = -0.74140517760932234;
              actLayer.w[0, 1] = -0.74140517760932234;
              actLayer.w[1, 0] = -1.5095922195846967;
              actLayer.w[1, 1] = -1.5095922195846967;
              actLayer.w[2, 0] = 2.2496847696330211;
              actLayer.w[2, 1] = 2.2496847696330211;
              actLayer.w[3, 0] = 3.8834780819310732;
              actLayer.w[3, 1] = 3.8834780819310732;

              actLayer.offs[0] = -3.4558593149581238;
              actLayer.offs[1] = -3.4558593149581238;

              actLayer = net.ElementAt(1);
              actLayer.w[0, 0] = 60.203657487527231;
              actLayer.w[0, 1] = 3.0687591009517741;
              actLayer.w[1, 0] = 60.203657487527231;
              actLayer.w[1, 1] = 3.0687591009517741;

              actLayer.offs[0] = -10.2965449509738;
              actLayer.offs[1] = -31.731916963234447;*/

            samples = data.values.Count;
            dataLength = data.dataLength;
            dgDataView.RowCount = samples;
            dgDataView.ColumnCount = 10;

            dgDataView.Columns[0].HeaderText = "x1";
            dgDataView.Columns[1].HeaderText = "x2";
            dgDataView.Columns[2].HeaderText = "x3";
            dgDataView.Columns[3].HeaderText = "x4";
            dgDataView.Columns[4].HeaderText = "y";
            dgDataView.Columns[5].HeaderText = "Res";
            dgDataView.Columns[6].HeaderText = "[%]";
            for (i = 0; i < samples; i++)
            {
                dgDataView.Rows[i].HeaderCell.Value = (i + 1).ToString();
                for (j = 0; j <= features; j++)
                {
                    cell = dgDataView[j, i];
                    cell.Value = Math.Round(data.values.ElementAt(i)[j], 4).ToString();
                }
            }
        }


        private double[] ForwardProp(double[] x)
        {
            int i, j, k;
            TLayer actLayer = net.ElementAt(0);
            double[] actX = new double[x.Length];
            for (i = 0; i < x.Length; i++)
              actX[i] = x[i];

            for (i = 0; i < layers; i++)
            {
                for (j = 0; j < actLayer.featuresOut; j++)
                {
                    actLayer.x[j] = actLayer.offs[j];
                    for (k = 0; k < actLayer.featuresIn; k++)
                    {
                        actLayer.x[j] = actLayer.x[j] + actX[k] * actLayer.w[k, j];
                    }
                    actLayer.o[j] = actLayer.Act(actLayer.x[j]);
                }

                for (j = 0; j < actLayer.x.Length; j++)
                    actX[j] = actLayer.o[j];
              
                if(i < layers - 1)
                    actLayer = net.ElementAt(i + 1);
            }
            return actLayer.o;
        }

      
        private void bt_Calc_Click(object sender, EventArgs e)
        {
            int i, k;
            double[] res;
            double[] tempX = new double[features];
            DataGridViewCell cell;
            TLayer actLayer = net.ElementAt(0);
           
            // print data
            for (i = 0; i < samples; i++)
            {
                for (k = 0; k < features; k++)
                {
                    tempX[k] = data.values.ElementAt(i)[k];
                }
                res = ForwardProp(tempX);
                cell = dgDataView[5, i];
                if ((res[0] < 0.5) && (res[1] < 0.5))
                {
                    cell.Value = "Iris_setosa";
                }
                else
                {
                    if (res[1] < 0.5)
                    {
                        cell.Value = "Iris-versicolor";
                    }
                    else
                    {
                        cell.Value = "Iris_virginica";
                    }
                }
                double tempRes = 0;
                if (res[0] < 0.5)
                    tempRes = tempRes + (1 - res[0]) * (1 - res[0]);
                else
                    tempRes = tempRes + res[0] * res[0];
                if (res[1] < 0.5)
                    tempRes = tempRes + (1 - res[1]) * (1 - res[1]);
                else
                    tempRes = tempRes + res[1] * res[1];
                cell = dgDataView[6, i];
                cell.Value = Math.Round(Math.Sqrt(tempRes/2) * 100, 4).ToString();
            }
        }
    }
}
