﻿
using System;

namespace WindowsFormsApplication1
{
    public delegate double function(double value);

    class TLayer
    {
        public int featuresIn;
        public int featuresOut;
        public double[] x;
        public double[] o;
        public double[,] w;
        public double[] offs;
      
        public function Act;
        public function dAct;

        public TLayer(int iFeaturesIn, int iFeaturesOut)
        {
            int j, k;
            featuresIn = iFeaturesIn;
            featuresOut = iFeaturesOut;
            w = new double[featuresIn, featuresOut];
            o = new double[featuresOut];
            offs = new double[featuresOut];
            x = new double[featuresOut];
      
            for (j = 0; j < featuresOut; j++)
            {
                offs[j] = 0;
                for (k = 0; k < featuresIn; k++)
                {
                    w[k, j] = 0.5;
                }
            }
            //Act = Sigmoid; // for the use of the sigmoid function
            //dAct = dSigmoid;

            Act = TanH; // for the use of the tanh function
            dAct = dTanH;
        }


        public double Sigmoid(double x)
        {
            return 1.0 / (1.0 + Math.Exp(- 0.5 * x));
        }


        public double dSigmoid(double x)
        {
            return  0.5 * x * (1 - x);
        }

        public double TanH(double x)
        {
            return Math.Tanh(x) / 2.0 + 0.5;
        }

        public double dTanH(double x)
        {
            return (1 - x * x) / 2;
        }

        public double Relu(double x)
        {
            if (x > 0)
                return x;
            else
                return 0;
        }

        public double dRelu(double x)
        {
            if (x > 0)
                return 1;
            else
                return 0;
        }

        public double Neutral(double x)
        {
            return x;
        }


        public double dNeutral(double x)
        {
            return 1;
        }
    }
}
